Uses Cfg 
Uses FBase
Uses Dir

Const	DatFile	=	'MystTic.Dat'
Const	FFree	=	16
Const	FFail	=	8
Const	FDel	=	4
Const	FInv	=	2
Const	FOff	=	1

Var CfgInDir	String
Var CfgTag		String Array(1..15)
Var CfgFBFile	String Array(1..15)

Var File2Move	String
Var FileArea    String
Var FileDesc	String	Array(1..15)
Var DescLines	Integer
Var DestDir		String
Var LogFile		String

Var FFName		String
Var FSize		LongInt
Var DT			LongInt
Var Uploader	String
Var Flags		Byte
Var Pointer		LongInt
Var Lines		Byte
Var DLs			Word

Var isOff		Boolean
Var IsInv		Boolean
Var IsDel		Boolean
Var IsFail		Boolean
Var IsFree		Boolean
Var IsNorm		Boolean

Procedure GetFlags (Flgs Byte)
Begin
	isOff:=False
	IsInv:=False
	IsDel:=False
	IsFail:=False
	IsFree:=False
	IsNorm:=False
	If Flgs > FFree-1	Then	IsFree:=True	Flgs:=Flgs-FFree	Endif
	If Flgs > FFail-1	Then	IsFail:=True	Flgs:=Flgs-FFail	Endif
	If Flgs > FDel-1	Then	IsDel:=True		Flgs:=Flgs-FDel		Endif
	If Flgs > FInv-1	Then	IsInv:=True		Flgs:=Flgs-FInv		Endif
	If Flgs > FOff-1	Then	isOff:=True		Flgs:=Flgs-FOff		Endif
	If not isfree and not isfail and not isdel and not isinv and not isoff then
		IsNorm:=True
	endif
Pend


Procedure Add2Log(Str1 String)
Begin
	LogFile:=CfgLogsPath+'MystTic.log'
	If Not fExist(Logfile) Then
		fOpen(8,text,Rewrite,Logfile)
	Else
		fOpen(8,text,Append,Logfile)
	Endif
	fWriteLn(8,DateStr(DateTime,1) + ' ' + TimeStr(DateTime,1)+ ' ' + Str1)
	fClose(8)
	WriteLn(Str1)
Pend

Procedure GetTicInfo( Str1 String)
Var I1	Integer
Begin
	DescLines:=1
	I1:=Pos('Area ',Str1)
	If I1 > 0 Then
		FileArea:=Str1
		Delete(FileArea,5,1)
	Endif
	I1:=Pos('File ',Str1)
	If I1 > 0 Then
		File2Move:=Str1
		Delete(File2Move,5,1)
	Endif
	I1:=Pos('Desc ',Str1)
	If I1 > 0 Then
		FileDesc(DescLines):=Str1
		Delete(FileDesc(DescLines),5,1)
		Add2Log('Desc ' + Int2Str(DescLines) + ' ' + FileDesc(DescLines))
		DescLines:=DescLines+1
	Endif
Pend

Procedure SaveEntry(DirFile String, TheFile String)
Var DirPath	String
Var DesPath	String
Var I7		Integer
Begin

	Add2Log(' $ Saving Entry')
	DirPath:=CfgDataPath+DirFile+'.dir'
	DesPath:=CfgDataPath+DirFile+'.des'
	If Not fExist(DesPath) Then
		fOpen(5,Bin,Rewrite,DesPath)
	Else
		fOpen(5,Bin,Append,DesPath)
	Endif
	Pointer:=FileSize(5)
	Add2Log(' $$ Saving ' + Int2Str(DescLines) + ' lines of description')
	For I7:=1 to DescLines
		fWriteRec(5,FileDesc(I7),Length(FileDesc(I7)))
	Fend
	fClose(5)
	Lines:=DescLines
	DLs:=0
	Flags:=0
	UpLoader:='MystTic'

	If fExist(TheFile) Then
		FindFirst(theFile,Anyfile)
		If DosError = 0 Then
			FSize:=DirSize	
			DT:=DirTime
			FFName:=DirName
		Endif
		FindClose
	Endif
	
	If Not fExist(DirPath) Then
		fOpen(4,Bin,Rewrite,DirPath)
	else
		fOpen(4,Bin,Append,DirPath)
	Endif
	fWriteRec(4,FFName,70)
	fWriteRec(4,FSize)
	fWriteRec(4,DT)
	fWriteRec(4,Uploader,30)
	fWriteRec(4,Flags)
	fWriteRec(4,Pointer)
	fWriteRec(4,Lines)
	fWriteRec(4,DLs)
	fClose(4)
Pend


Function CheckIfThere(Str1 String):Boolean
Begin
	If fExist(Str1) Then
		CheckIfThere:=True
	Else
		CheckIfThere:=False
	Endif
Pend

Procedure DelListing(TheFile String)
Var Innf	String
Var Outf	String
Begin
	Innf:=CfgDataPath+TheFile+'.dir'
	Outf:=CfgDataPath+TheFile+'.dir.tmp'
	fOpen(7,Bin,Rewrite,Outf)
	If fExist(Innf) Then
		fOpen(3,Bin,Reset,Innf)
		While not eof(3)
			fReadRec(3,FFName,70) 
			fReadRec(3,FSize) 
			fReadRec(3,DT) 
			fReadRec(3,Uploader,30) 
			fReadRec(3,Flags) 
			fReadRec(3,Pointer) 
			fReadRec(3,Lines) 
			fReadRec(3,DLs) 
			GetFlags(Flags)
			If FFName = TheFile And Not IsDel Then 
				Flags:=Flags+FDel
			Endif
			fWriteRec(7,FFName,70) 
			fWriteRec(7,FSize) 
			fWriteRec(7,DT) 
			fWriteRec(7,Uploader,30) 
			fWriteRec(7,Flags) 
			fWriteRec(7,Pointer) 
			fWriteRec(7,Lines) 
			fWriteRec(7,DLs) 
		Wend	
		fClose(3)	
	Endif
	fClose(7)	

	If fExist(Outf)	Then
		If fExist(Innf)	Then
			fErase(Innf)
		Endif
		If fCopy(OutF,InnF) Then
			fErase(OutF)
		Endif
	Endif
Pend

Function CheckIfListed(DirFile String) : Boolean
Var Path	String
Var RetVal	Boolean
Begin
	RetVal:=False
	Path:=CfgDataPath+DirFile+'.dir'
	If fExist(Path) Then
		fOpen(3,Bin,Reset,Path)
		While not eof(3)
			fReadRec(3,FFName,70) 
			fReadRec(3,FSize) 
			fReadRec(3,DT) 
			fReadRec(3,Uploader,30) 
			fReadRec(3,Flags) 
			fReadRec(3,Pointer) 
			fReadRec(3,Lines) 
			fReadRec(3,DLs) 
			GetFlags(Flags)
			If FFName = File2Move and Not IsDel	Then 
				RetVal:=True 
			Endif
		Wend	
		fClose(3)	
	Endif
	CheckIfListed:=RetVal
Pend

Function ProcessFile : boolean
Var From	String
Var ToTo	String
Var I3		Integer
Var I4		Integer
Var CurCfg	Integer
Var Ok2Move	Boolean

Var T1Size	LongInt	
Var T2Size	LongInt	
Var FoundA	Boolean
Var RetVal	Boolean
Begin
	RetVal:=False
	Add2Log(' + Processing file '+File2Move + ' in area ' + FileArea )
	Ok2Move:=True
	FoundA:=False
	For I3:=1 to 15
		If CfgTag(I3) = FileArea Then
			FoundA:=True
			I4:=1
			While GetFBase(I4)
				If FBFileName = CfgFBFile(I3)
					ToTo:=FBPath
					CurCfg:=I3
				Endif
				I4:=I4+1
			Wend
		Endif
	Fend	
	If Not FoundA Then
		Add2Log('Area ' + FileArea + ' not defined.')
		Add2Log('Run MTicCfg to configure this File Echo')
		Add2Log('and run MTic again.')
		Add2Log('Skipping file: '+File2Move)
		Ok2Move:=False
		RetVal:=False
	Else
		From:=CfgInDir+File2Move
		ToTo:=ToTo+File2Move
		If CheckIfThere(CfgFBFile(CurCfg)) Then
			Add2Log(' e File ' + File2Move + ' is already there!')
			Ok2Move:=True
		Else
			Add2Log(' e File ' + File2Move + ' is NOT there!')
			RetVal:=True
		Endif
		If CheckIfListed(CfgFBFile(CurCfg)) Then
			Add2Log(' o File ' + File2Move + ' is already listed.  ')
			Add2Log(' oo Deleting file from the listing.')
			DelListing(File2Move)
			If CheckIfListed(CfgFBFile(CurCfg)) Then
				Add2Log(' ooo Unable to remove file from listing.')
				Ok2Move:=False
			Else
				Ok2Move:=True
			Endif
		else
			Add2Log(' oo File not already listed!')
		Endif
		If Ok2Move Then
			Add2Log(' x Moving ' + File2Move+ ' To ' + CfgTag(CurCfg))
			SaveEntry(CfgFBFile(CurCfg),From)
			If fExist(ToTo) Then
				fErase(ToTo)
			Endif
			if fexist(From) Then
				If fCopy(From,ToTo) then		# If the file got copied ok.
						findFirst(From,AnyFile)
						If DosError = 0 Then
							T1Size:=DirSize     # Check the size of the source
						Endif
					FindClose
						findFirst(Toto,AnyFile)
						If DosError = 0 Then
							T2Size:=DirSize     # Check the size of the dest.
						Endif
					FindClose
					If T1Size=T2Size Then       # If they match
						fErase(From)            # Delete the source.
						RetVal:=True
					Else
						RetVal:=False
					Endif
				Else
					RetVal:=True				# File is not in source dir
				Endif							# but we delete TIC file	
			Endif								# anyways.
		Endif
	Endif
	ProcessFile:=RetVal
Pend

Procedure DoTics
Var	Path	String
Var	TicFile	String
Var TTXT1	String
Begin
	Add2Log('* Processing TIC files.')
	Path:=CfgInDir+'*.TIC'
	FindFirst(Path,AnyFile)
	While DosError = 0
		TicFile:=CfgInDir+DirName
		If fExist(TicFile) Then
			fOpen(2,Text,Reset,TicFile)
			While Not eof(2)
				fReadLn(2,TTxT1)
				GetTicInfo(TTxt1)
			Wend
			fClose(2)
		Endif
		If ProcessFile Then
			fErase(TicFile)
		Endif
		FindNext
	Wend
	FindClose
Pend

Function ReadCfg : boolean
Var Path	String
Var I1		Integer
Var RetVal	Boolean
Begin
	GetCfg
	Path:=CfgDataPath+DatFile
	If Not fExist(Path) Then
		add2Log('|CRError, File not found.' + Path)
		Add2Log('MTicCfg must be run first.|CR|PA')
		RetVal:=false
	Else
		fOpen(1,Text,Reset,Path)
		fReadLn(1,CfgInDir)
		For I1:=1 to 15
			If Not Eof(1) then
				fReadLn(1,CfgTag(I1))
				fReadLn(1,CfgFBFile(I1))
			Endif
		Fend
		fClose(1)
		RetVal:=True
	Endif
	ReadCfg:=RetVal
Pend

Begin
	if ReadCfg then
		DoTics
	Endif
	Write('|CR|PA')
end
